AttacherMovingEvent = {};
AttacherMovingEvent_mt = Class(AttacherMovingEvent, Event);

InitEventClass(AttacherMovingEvent, "AttacherMovingEvent");

function AttacherMovingEvent:emptyNew()
    local self = Event:new(AttacherMovingEvent_mt);
    self.className = "AttacherMovingEvent";
    return self;
end;

function AttacherMovingEvent:new(object, attacherMoved, attacherState)
    local self = AttacherMovingEvent:emptyNew()
    self.object = object;
	self.attacherMoved = attacherMoved;
	self.attacherState = attacherState;
    return self;
end;

function AttacherMovingEvent:readStream(streamId, connection)
    self.object = networkGetObject(streamReadInt32(streamId));
	self.attacherMoved  = streamReadBool(streamId);
    self.attacherState = streamReadInt8(streamId);
    self:run(connection);
end;

function AttacherMovingEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
    streamWriteBool(streamId, self.attacherMoved);
    streamWriteInt8(streamId, self.attacherState);
end;

function AttacherMovingEvent:run(connection)
  self.object:attacherMoving(self.attacherMoved, self.attacherState, true);
	if not connection:getIsServer() then
		g_server:broadcastEvent(AttacherMovingEvent:new(self.object, self.attacherMoved, self.attacherState), nil, connection, self.object);
	end;
end;

function AttacherMovingEvent.sendEvent(object, attacherMoved, attacherState, noEventSend)
  if noEventSend == nil or noEventSend == false then
    if g_server ~= nil then
      g_server:broadcastEvent(AttacherMovingEvent:new(object, attacherMoved, attacherState), nil, nil, object);
    else
      g_client:getServerConnection():sendEvent(AttacherMovingEvent:new(object, attacherMoved, attacherState));
    end;
  end;
end;

